// Code generated by cdpgen. DO NOT EDIT.

package animation

import (
	"github.com/mafredri/cdp/protocol/dom"
)

// Animation Animation instance.
type Animation struct {
	ID           string  `json:"id"`           // `Animation`'s id.
	Name         string  `json:"name"`         // `Animation`'s name.
	PausedState  bool    `json:"pausedState"`  // `Animation`'s internal paused state.
	PlayState    string  `json:"playState"`    // `Animation`'s play state.
	PlaybackRate float64 `json:"playbackRate"` // `Animation`'s playback rate.
	StartTime    float64 `json:"startTime"`    // `Animation`'s start time.
	CurrentTime  float64 `json:"currentTime"`  // `Animation`'s current time.
	// Type Animation type of `Animation`.
	//
	// Values: "CSSTransition", "CSSAnimation", "WebAnimation".
	Type   string  `json:"type"`
	Source *Effect `json:"source,omitempty"` // `Animation`'s source animation node.
	CSSID  *string `json:"cssId,omitempty"`  // A unique ID for `Animation` representing the sources that triggered this CSS animation/transition.
}

// Effect AnimationEffect instance
type Effect struct {
	Delay          float64            `json:"delay"`                   // `AnimationEffect`'s delay.
	EndDelay       float64            `json:"endDelay"`                // `AnimationEffect`'s end delay.
	IterationStart float64            `json:"iterationStart"`          // `AnimationEffect`'s iteration start.
	Iterations     float64            `json:"iterations"`              // `AnimationEffect`'s iterations.
	Duration       float64            `json:"duration"`                // `AnimationEffect`'s iteration duration.
	Direction      string             `json:"direction"`               // `AnimationEffect`'s playback direction.
	Fill           string             `json:"fill"`                    // `AnimationEffect`'s fill mode.
	BackendNodeID  *dom.BackendNodeID `json:"backendNodeId,omitempty"` // `AnimationEffect`'s target node.
	KeyframesRule  *KeyframesRule     `json:"keyframesRule,omitempty"` // `AnimationEffect`'s keyframes.
	Easing         string             `json:"easing"`                  // `AnimationEffect`'s timing function.
}

// KeyframesRule Keyframes Rule
type KeyframesRule struct {
	Name      *string         `json:"name,omitempty"` // CSS keyframed animation's name.
	Keyframes []KeyframeStyle `json:"keyframes"`      // List of animation keyframes.
}

// KeyframeStyle Keyframe Style
type KeyframeStyle struct {
	Offset string `json:"offset"` // Keyframe's time offset.
	Easing string `json:"easing"` // `AnimationEffect`'s timing function.
}
